'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _loader = void 0;


var start = function start(text) {
  if (_loader) {
    if (text) _loader.text = text;
    _loader.start();
  }

  return _loader;
};

var setText = function setText(text) {
  if (_loader) _loader.text = text;
  return _loader;
};

var get = function get() {
  return _loader;
};

var stop = function stop() {
  if (_loader) _loader.stop();
  return _loader;
};

var on = function on() {
  if (!_loader) _loader = (0, _ora2.default)({ text: '' });
  return _loader;
};

var off = function off() {
  stop();
  _loader = null;
  return _loader;
};

var loader = {
  on,
  off,
  stop,
  start,
  setText,
  get
};

exports.default = loader;
//# sourceMappingURL=loader.js.map